#
# -- setup.py -- your module's install file
#
 
# import distutils
from distutils.core import setup, Extension
# for pasting together file lists
from glob import glob
# for handling path names in a os independent way
from os.path import join;

import os
 
# grab all of the .h and .cpp files in src/ and include/
srcList = [ x for x in glob(join("src/WiimoteAPI", "*.cpp")) ]

# set the include directories
incDirs = [ "C:\Program Files\Microsoft Visual Studio 9.0\VC\include" , "C:/WinDDK/7600.16385.0/inc/api", "C:/users/tgrim/OpenCV-2.1.0/include/opencv"]
#, "P:\graphics\Tools\opencv\include\opencv" ]

# set the libraries names
#debug may be an issue here.
libs = ["cv210","cvaux210","cxcore210"]




#libs = ["msvcrt"]
#libs = []

# set the libraries directories
lib_dirs = ["C:/WinDDK/7600.16385.0/lib/wxp/i386", "C:/users/tgrim/OpenCV-2.1.0/lib/Release"]

#Get rid of warning about exception handling....
ext_comp_args = ['/EHsc'] 
#ext_link_args = ["/DEBUG", "/PDB:""U:\\test.pdb"""]
#ext_link_args = ["/MANIFEST:NO"]
#ext_link_args = ['/NODEFAULTLIB:"MSVCP90"']
#, '/NODEFAULTLIB:"MSVCR90"']
ext_link_args = []



WiimoteAPIMods = Extension(		'WiimoteAPI',
							sources = srcList,
							include_dirs = incDirs,
							libraries = libs,
							library_dirs = lib_dirs,							
							extra_link_args = ext_link_args,
							extra_compile_args = ext_comp_args,
							 )


setup( name="WiimoteAPI",
        version="1.0",
        description="WiimoteAPI",
        author="Yoram Griguer",
        author_email="griguer@wisc.edu",
        url="The URL of your work",
        ext_modules=[WiimoteAPIMods],
         )
