#include "cv.h"

#include <time.h>

class KalmanFilter
{
public:
	KalmanFilter();
	~KalmanFilter();

	virtual void predictionBegin(float x, float y);
	virtual void predictionUpdate(float x, float y);
	virtual void predictionReport();

	bool alreadyBegun(){return m_alreadyBegun;}

	CvMat* getState() {return m_state;}

private:
	CvKalman *m_kalman;
	CvRandState m_rng;
	CvMat* m_state;
	CvMat* m_processNoise;
	CvMat* m_measurement;
	//CvMat* m_measurementNoise;
	bool m_haveMeasurement;
	clock_t m_timeLastMeasurement;
	bool m_alreadyBegun;
};