#ifndef _WIIMOTEBUTTONSSTATES__
#define _WIIMOTEBUTTONSSTATES__

#include <map>

#include "wiimote.h"

class WiimoteButtonsStates
{
public:
	
	WiimoteButtonsStates(wiimote* p_wiimote);
	virtual ~WiimoteButtonsStates(){}

	enum enum_button
	{
		A,
		B,
		Minus,
		Plus,
		Home,
		One,
		Two,
		Up,
		Down,
		Left,
		Right,
	};

	enum enum_nunchuk
	{
		Z,
		C
	};

	enum enum_state
	{
		NOT_PRESSED,
		JUST_PRESSED,
		HELD,
		JUST_RELEASED
	};

	enum_state getButtonState(enum_button button);
	enum_state getButtonState(enum_nunchuk button);

	std::map<enum_button,enum_state>::iterator getIterButtonState(enum_button button);
	std::map<enum_nunchuk,enum_state>::iterator getIterButtonState(enum_nunchuk button);

	void updateButtonsStates();
	void updateNunchukStates();

	bool isJustPressed(enum_button button);
	bool isJustPressed(enum_nunchuk button);

	bool isHeld(enum_button button);
	bool isHeld(enum_nunchuk button);

	bool isJustReleased(enum_button button);
	bool isJustReleased(enum_nunchuk button);


private:
	
	std::map<enum_button,enum_state> m_statesButtons;
	std::map<enum_nunchuk,enum_state> m_statesNunchuk;
	wiimote* m_wiimote;

};


#endif // _WIIMOTEBUTTONSSTATES__