import sys
sys.path.append('./build/lib.win32-2.6')

import threading
import time

import Shared
import PointerModule

class Overlay_Thread(threading.Thread):

	running = 1
	id_wiimote = -1
	lock = None
	refup = None
	def __init__(self,id_wiimote,lock,sup):
		refup = sup
		self.id_wiimote = id_wiimote
		self.lock = lock
		threading.Thread.__init__(self)

	def run(self):
		
		width = 512
		height = 512
		
		# Init the overlay
		PointerModule.Init(self.id_wiimote,width/15,height/15)
		
		while self.running:
			self.lock.acquire()
			
			# Display the pointer
			if Shared.pointing[self.id_wiimote] and not Shared.busy \
				and Shared.ledsVisible[self.id_wiimote]:
				
				# The pointer can be displayed everywhere on the screen, even outside PyMOL
				# So we have find where is the area where we want to display it
				xScreen = Shared.pos_pointer[self.id_wiimote][0] + Shared.viewport[0] + Shared.window_x
				yScreen = (Shared.viewport[3] - Shared.pos_pointer[self.id_wiimote][1]) + Shared.window_y
				
				
				# If the size of Pymol's window changes, we change the size of the pointer
				# To do so, we have to reinitialize it
				width_cur = Shared.viewport[2]
				height_cur = Shared.viewport[3]
				
				if width_cur != width or height_cur != height:
					width = width_cur
					height = height_cur
					PointerModule.Reset(self.id_wiimote,width/15,height/15)
				
				PointerModule.DrawPointer(self.id_wiimote,xScreen,yScreen)
				
				# Permits to wait that the position of the pointer is computed
				time.sleep(0.001)
				
			self.lock.release()
