import Utilities
import math

from pymol import cmd
from pymol.callback import Callback
from pymol.opengl.gl import *
from pymol.opengl.glu import *
from pymol.opengl.glut import *

import time

import Shared

class callback_pointer:
	running = 1
	controller_index = -1     #replacing the id_wiimote with this. This is the index into Shared.controller_list[]
	refup = None
	flipflop = True
	def __init__(self, controller_index, sup):
		refup = sup
		self.controller_index = controller_index
		self.flipflop = True

	def runCallback(self):
		glDisable(GL_DEPTH_TEST)			
		glDisable(GL_LIGHTING)
		if( Shared.viewport != None and len(Shared.viewport) > 3 and not Shared.hide_pointers and Shared.depthTracker.hasBuffer
				and not (len(Shared.ViewportSet[0]) == 1 and len(Shared.ViewportSet[1]) == 1)):
			if(Shared.Molecule_moving):
		#xScreen = Shared.pos_pointer[self.id_wiimote][0]
				#yScreen = Shared.pos_pointer[self.id_wiimote][1]
				#dont run this thread if we don't have a controller.
				if not ((self.controller_index) < len(Shared.controller_list)):
					return
				if not (Shared.controller_list[self.controller_index].PointerEnabled() == True):
					return
				position = [Shared.controller_list[self.controller_index].GetPointerPosition()[0] * Shared.viewport[2] + Shared.viewport[0],
							Shared.controller_list[self.controller_index].GetPointerPosition()[1] * Shared.viewport[3] + Shared.viewport[1]]
				#temp = gluUnProject(Shared.controller_list[self.controller_index].pointer_position[0],
				#									Shared.controller_list[self.controller_index].pointer_position[1], .5)
				temp = gluUnProject(position[0], position[1], .5)
				temp1 = gluProject(temp[0],temp[1],temp[2])
				
				
				xScreen = temp1[0]
				yScreen = temp1[1] - 20
				width = Shared.viewport[2]
				height = Shared.viewport[3]
				glDisable(GL_LIGHTING)
				glMatrixMode(GL_PROJECTION)
				glPushMatrix()
				glLoadIdentity()
				glOrtho(0,width,0,height, -2, 0)
				
				tempView1 = Shared.ViewportSet[0]
				tempView2 = Shared.ViewportSet[1]
				if(tempView1[0] > tempView2[0]):
					width =tempView1[2]
				else:
					width =tempView2[2]
				   
				glMatrixMode(GL_MODELVIEW)
				glPushMatrix()
				glLoadIdentity()
				glTranslatef(0,0,1.7)
				glBegin(GL_TRIANGLES)
				if(self.controller_index == 0):
					glColor3f(.7,.7,.7)
				if(self.controller_index == 1):
					glColor3f(.8,.2,.5)
				if(self.controller_index == 2):
					glColor3f(.3,.6,.9)
				if(self.controller_index == 3):
					glColor3f(.7,1,.4)
				

#				xScreen += 1
				yScreen += 2
				width = width * 2
				height = height * 2
				glVertex3f(xScreen, yScreen,0)
				glVertex3f(xScreen, yScreen -6 *(width / 640),0)
				glVertex3f(xScreen  + 1.5 * (width / 640) , yScreen - 4.5 * (width / 640),0)
				
				glVertex3f(xScreen, yScreen,0)
				glVertex3f(xScreen + 4.5* (width / 640), yScreen - 4.5 * (width / 640),0)
				glVertex3f(xScreen  + 1.5 * (width / 640) , yScreen - 4.5 *(width / 640),0)
				
				glEnd()

				glBegin(GL_LINES)
				glColor3f(0,0,0)

				glVertex3f(xScreen, yScreen,0)
				glVertex3f(xScreen , yScreen - 6 *(width / 640),0)
				
				glVertex3f(xScreen, yScreen - 6 * (width / 640),0)
				glVertex3f(xScreen + 1.5 * (width / 640), yScreen - 4.5 *(width / 640),0)
				
				glVertex3f(xScreen + 1.5 * (width / 640), yScreen - 4.5 * (width / 640),0)
				glVertex3f(xScreen + 4.5 * (width / 640), yScreen - 4.5 * (width / 640),0)
				
				
				glEnd()


				glMatrixMode(GL_PROJECTION)
				glPopMatrix()
				
				glMatrixMode(GL_MODELVIEW)
				glPopMatrix()
				glEnable(GL_LIGHTING)
				if(len(Shared.pointers_hidden) > self.controller_index):
					Shared.pointers_hidden[self.controller_index] = False	
			else:	
				#dont run this thread if we don't have a controller.
				if not ((self.controller_index) < len(Shared.controller_list)):
					return
				if not (Shared.controller_list[self.controller_index].PointerEnabled() == True):
					return
				position=Shared.controller_list[self.controller_index].pointer_position
				realposition = [Shared.controller_list[self.controller_index].pointer_position[0] * Shared.viewport[2] + Shared.viewport[0],
							Shared.controller_list[self.controller_index].pointer_position[1] * Shared.viewport[3] + Shared.viewport[1]]
				temp1 = [0.0,0.0,0.0]
				ModelPointerPositions = [0,0]
				ModelPointerPositionsRight = [0,0]
				ModelPointerPositionsUp = [0,0]
				temp = [0.0,0.0,0.0]
				if(len(Shared.ViewportSet[0]) != 1):
					realposition = [[position[0] * Shared.ViewportSet[0][2] + Shared.ViewportSet[0][0],
										position[1] * Shared.ViewportSet[0][3] + Shared.ViewportSet[0][1]],
										[position[0] * Shared.ViewportSet[1][2] + Shared.ViewportSet[1][0],
										position[1] * Shared.ViewportSet[1][3] + Shared.ViewportSet[1][1]]]
					temp1[2] = 0.3
					for i in range(2):
						ModelPointerPositions[i] = list(gluUnProject(realposition[i][0],realposition[i][1],temp1[2],
														Shared.ModelMatrixSet[i],Shared.ProjectMatrixSet[i], Shared.ViewportSet[i]))
						ModelPointerPositionsRight[i] = list(gluUnProject(realposition[i][0] + 1,realposition[i][1],temp1[2],
														Shared.ModelMatrixSet[i],Shared.ProjectMatrixSet[i], Shared.ViewportSet[i]))
				
					temp = [(ModelPointerPositions[0][0] + ModelPointerPositions[1][0])/2,
							(ModelPointerPositions[0][1] + ModelPointerPositions[1][1])/2,
							(ModelPointerPositions[0][2] + ModelPointerPositions[1][2])/2]
					tempPixelRight = [(ModelPointerPositionsRight[0][0] + ModelPointerPositionsRight[1][0])/2,
							(ModelPointerPositionsRight[0][1] + ModelPointerPositionsRight[1][1])/2,
							(ModelPointerPositionsRight[0][2] + ModelPointerPositionsRight[1][2])/2]
	
				else:
					if(not Shared.Molecule_moving):
						temp1 = Shared.depthTracker.getLocalPOIVar(realposition[0],realposition[1],8)
						if(temp1[2] >= .95):
							temp1[2] = 0.3
						else:
							temp1[2] = 0.3
					temp = list(gluUnProject(realposition[0],realposition[1],temp1[2], Shared.ModelMatrixSet[1],Shared.ProjectMatrixSet[1], Shared.ViewportSet[1]))
					tempPixelRight = list(gluUnProject(realposition[0] + 1,realposition[1],temp1[2], Shared.ModelMatrixSet[1],Shared.ProjectMatrixSet[1],Shared.ViewportSet[1]))
					
				horzScale = math.sqrt(math.pow(tempPixelRight[0] - temp[0],2) +\
							      math.pow(tempPixelRight[1] - temp[1],2) +\
							      math.pow(tempPixelRight[2] - temp[2],2)) #distance per pixel
					
				vertScale = horzScale
						
				#position = Shared.controller_list[self.controller_index].pointer_position
				view = cmd.get_view()
				distanceFromCamera = math.sqrt(math.pow(view[14] - view[11] - temp[2],2))
						
				xScreen =0# temp1[0]
				yScreen =0# temp1[1] - 20
				width = Shared.viewport[2]
				height = Shared.viewport[3]
						
				#temp = [position[0],position[1],0]
				glPushMatrix()
						
				glTranslatef(temp[0],temp[1],temp[2])
				glMultMatrixf([view[0],view[3],view[6],0
					       ,view[1],view[4],view[7], 0
					       ,view[2],view[5],view[8], 0
					       , 0, 0, 0, 1])	
				glBegin(GL_TRIANGLES)
				if(self.controller_index == 0):
					glColor3f(.7,.7,.7)
				if(self.controller_index == 1):
					glColor3f(.8,.2,.5)
				if(self.controller_index == 2):
					glColor3f(.3,.6,.9)
				if(self.controller_index == 3):
					glColor3f(.7,1,.4)
				

				width = width * 2
				height = height * 2
				glVertex3f(xScreen, yScreen,0)
				glVertex3f(xScreen, yScreen -6 * vertScale * (width / 640),0)
				glVertex3f(xScreen  + 1.5 * horzScale * (width / 640) , yScreen - 4.5 * vertScale * (width / 640),0)
				
				glVertex3f(xScreen, yScreen,0)
				glVertex3f(xScreen + 4.5* horzScale * (width / 640), yScreen - 4.5 *  vertScale * (width / 640),0)
				glVertex3f(xScreen  + 1.5 * horzScale * (width / 640) , yScreen - 4.5 * vertScale * (width / 640),0)
				
				glEnd()

				glBegin(GL_LINES)
				glColor3f(0,0,0)

				glVertex3f(xScreen, yScreen,0)
				glVertex3f(xScreen , yScreen - 6 * vertScale * (width / 640),0)
				
				glVertex3f(xScreen, yScreen - 6 * vertScale * (width / 640),0)
				glVertex3f(xScreen + 1.5 * horzScale * (width / 640), yScreen - 4.5 * vertScale * (width / 640),0)
				
				glVertex3f(xScreen + 1.5 * horzScale * (width / 640), yScreen - 4.5 * vertScale * (width / 640),0)
				glVertex3f(xScreen + 4.5 * horzScale * (width / 640), yScreen - 4.5 * vertScale * (width / 640),0)
				
				
				glEnd()
				glPopMatrix()
				if(len(Shared.pointers_hidden) > self.controller_index):
					Shared.pointers_hidden[self.controller_index] = False			
		elif(self.flipflop):
			if(len(Shared.pointers_hidden) > self.controller_index):
				Shared.pointers_hidden[self.controller_index] = True
		self.flipflop = not self.flipflop
		glEnable(GL_DEPTH_TEST)
		glEnable(GL_LIGHTING)
	def get_extent(self):
		return [[0.0,0.0,0.0],[1.0,1.0,1.0]]
