import Utilities
import math

import sys
sys.path.insert(0, sys.prefix + '\\Lib\\site-packages')
#from opengl.gl import *
#from opengl.glu import *
#from opengl.glut import *


from pymol import cmd
from pymol.callback import Callback

from pymol.opengl.gl import *
from pymol.opengl.glu import *
from pymol.opengl.glut import *

import ZBufferHandler


import time

import Shared


class callback_gui(Callback):
	extent = [0,0,0]
	imagedata = []
	flipflop = True
	countDown = 10
	texture = glGenTextures(1)
	windowId = None
	def __call__(self):
		# Things we have to do in a callback but have nothing to do with the GUI
		#this auto-adjusts the slab to be reasonable for viewing cameras.
		glEnable(GL_BLEND)
		glDisable(GL_LIGHTING)
		if(Shared.bms.currentTextures == None):
			Shared.bms.currentTextures = glGenTextures(Shared.bms.max_height * Shared.bms.max_width)

		viewport = glGetFloatv(GL_VIEWPORT)
		if cmd.get("stereo") == "off" or viewport[0] != 0:
			Shared.viewport = viewport
		#getting the width and height to know how large to draw the cgui elements 
		# and for reading/writing pixel arrays to the screen.
		width = Shared.viewport[2]
		height = Shared.viewport[3]
		
		#we only want to get the depth buffer on the first draw of cgui each frame, otherwise on 
		# half of our frames, the actual gui will mess up our depth buffer calculations.
		#if(self.flipflop and Shared.getAPOI):
		#	self.imageData = glReadPixelsf(0,0,int(width - 1),int(height - 1),GL_DEPTH_COMPONENT)
		#	Shared.depthTracker.UpdateFocus(self.imageData,width,height)
		#	Shared.getAPOI = False
		temp1 = Shared.ViewportSet[0]
		temp2 = Shared.ViewportSet[1]
		if(len(temp1) == len(temp2) and len(temp1) == 4):
			if(temp1[0] < temp2[0] or temp1[1] < temp2[1]):
				Shared.viewport = temp1
			else:
				Shared.viewport = temp2
		viewport = glGetIntegerv(GL_VIEWPORT)
		if(viewport[0] == Shared.viewport[0] and
		   viewport[1] == Shared.viewport[1] and
		   viewport[2] == Shared.viewport[2] and
		   viewport[3] == Shared.viewport[3] and self.flipflop):   
			self.countDown -= 1
		
		if(self.flipflop and Shared.get_a_new_buffer):
			self.imageData = glReadPixelsf(viewport[0],viewport[1],viewport[2] -1, viewport[3] - 1, GL_DEPTH_COMPONENT)
			Shared.depthTracker.Update(self.imageData,viewport)
			Shared.get_a_new_buffer = False

		
		elif(self.flipflop and self.countDown <= 0 and not Shared.Molecule_moving ):
			viewport1 = list(Shared.ViewportSet[1])
			viewport0 = list(Shared.ViewportSet[0])
			self.imageData = glReadPixelsf(viewport[0],viewport[1],viewport[2] -1, viewport[3] - 1, GL_DEPTH_COMPONENT) 
			Shared.depthTracker.Update(self.imageData,viewport)
			self.countDown = 25
		

		
		self.flipflop = not self.flipflop
		# this draws the 3-D cursor for each of the participants. As master can change dynamically, it 
		# is entirely possible for several 3-D cursors to be displayed at one time, differentiated by color.
		for i in range(len(Shared.controller_list)):
			#if the wiimoteDevice is ready for us to draw the cursor, we draw it.
			if(Shared.controller_list[i].threed_cursor_visible and not \
					Shared.controller_list[i].threed_get_ray and Shared.controller_list[i].threed_cursor_state ==0):
				currentview = cmd.get_view()
				if(Shared.controller_list[i].threed_cursor_getUnProject):
					# To translate the pointing point of interest to real coordinates. Due to the snapping dynamic,
					# we can probably lose this function, but we have to make sure that nothing depends on this first
					# TODO: investigate this one and nuke it when we can.
					Shared.controller_list[i].threed_cursor_coords = \
						list(gluUnProject(Shared.controller_list[i].threed_cursor_coords[0],\
										  Shared.controller_list[i].threed_cursor_coords[1],\
										  Shared.controller_list[i].threed_cursor_coords[2]))
					Shared.controller_list[i].threed_cursor_getUnProject = False
				
				#this will be updated by the WiimoteDevice. the coordinates will either be the 
				# residue's coordinates, or the geometric coordinates, if the cursor is moving
				place_to_draw = Shared.controller_list[i].threed_cursor_resi_coords
				glColor3f(.9,.8,.2 * i)
				rad = Shared.controller_list[i].threed_cursor_size
				glTranslatef(place_to_draw[0],place_to_draw[1],place_to_draw[2])
				
				glBegin(GL_LINES)
				for k in range(10):
					for j in range(10):
						glVertex3f(rad * math.sin(k * math.pi / 10) * math.cos(j * math.pi / 5),
								rad * math.sin(k * math.pi / 10) * math.sin(j * math.pi / 5),
								rad * math.cos(k * math.pi / 10))
						glVertex3f(rad * math.sin((k+1) * math.pi / 10) * math.cos(j * math.pi / 5),
									rad * math.sin((k+1) * math.pi / 10) * math.sin(j * math.pi / 5),
									rad * math.cos((k+1) * math.pi / 10))
						glVertex3f(rad * math.sin(k * math.pi / 10) * math.cos(j * math.pi / 5),
									rad * math.sin(k * math.pi / 10) * math.sin(j * math.pi / 5),
									rad * math.cos(k * math.pi / 10))
						glVertex3f(rad * math.sin(k * math.pi / 10) * math.cos((j+1) * math.pi / 5),
									rad * math.sin(k * math.pi / 10) * math.sin((j+1) * math.pi / 5),
									rad * math.cos(k * math.pi / 10))
				glEnd()
				view = cmd.get_view()
				glPushMatrix()
				glPushMatrix()
				glMultMatrixf([view[0],view[3],view[6],0
							,view[1],view[4],view[7], 0
							,view[2],view[5],view[8], 0
							, 0, 0, 0, 1])
				scale_text = float(1.0/20000) * float(math.sqrt(math.pow(view[12] - view[9] + place_to_draw[0],2) + 
														math.pow(view[13] - view[10] + place_to_draw[1],2) +
														math.pow(view[14] - view[11] + place_to_draw[2],2)))
				glDisable(GL_DEPTH_TEST)
				glTranslatef(rad / math.sqrt(2),rad/ math.sqrt(2), 0)
				glScalef(scale_text,scale_text,scale_text)
				Utilities.drawLabel("Size : " + str("%.2f" % rad) + " Angstroms")
				glPopMatrix()
				glPushMatrix()
				glMultMatrixf([view[0],view[3],view[6],0
							,view[1],view[4],view[7], 0
							,view[2],view[5],view[8], 0
							, 0, 0, 0, 1])
				glTranslatef(- 2 * rad / math.sqrt(2), - 2 * rad/ math.sqrt(2), 0)
				glScalef(scale_text,scale_text,scale_text)
				if(Shared.controller_list[i].threed_cursor_selecting == 0):
					Utilities.drawLabel("Currently on : " +  str(Shared.controller_list[i].threed_cursor_resi) + "/" + str( Shared.controller_list[i].threed_cursor_atom_name))
				else:
					Utilities.drawLabel("Currently on : " +  str(Shared.controller_list[i].threed_cursor_resi))
				glPopMatrix()
				glPopMatrix()
				glTranslatef(-1 * place_to_draw[0],-1 * place_to_draw[1],-1 * place_to_draw[2])
				glEnable(GL_DEPTH_TEST)

		#This gets the 3d coordinates every moment it is running. This may need to be "slowed" to only occur whenever we're selecting
		for controller in Shared.controller_list:
			##I dont think we need this code anymore and it will help framerate to not be checking on this every frame.
			#if (controller.PointerEnabled() == True):
			#	[pointer1, pointer2] = controller.pointer_position
			#	Shared.rays[controller.deviceindex][0] = list(gluUnProject(pointer1, pointer2, 0))
			#	Shared.rays[controller.deviceindex][1] = list(gluUnProject(pointer1, pointer2, 1))
			if (controller.threed_get_ray == True):
				controller.threed_ray[0] = list(gluUnProject(controller.threed_cursor_coords[0],controller.threed_cursor_coords[1], 0))
				controller.threed_ray[1] = list(gluUnProject(controller.threed_cursor_coords[0],controller.threed_cursor_coords[1], 1))
				controller.threed_get_ray = False
				controller.placing_cursor = True
			if (controller.getSelectUnproject == 3):
				if(len(Shared.ViewportSet[0]) != 1):
					view1 = list(Shared.ViewportSet[0])
					view2 = list(Shared.ViewportSet[1])
					eye0 = [0,0,0]
					eye0[2] = Shared.depthTracker.getLocalPOIAtom(controller.SelectUnproject[0]*(view1[2]),
										      controller.SelectUnproject[1]*(view1[3]))[2]
					eye0[0] =  controller.SelectUnproject[0]*(view1[2]) + view1[0]
					eye0[1] = controller.SelectUnproject[1]*(view1[3]) + view1[1]

					eye1 = [0,0,0]
					eye1[2] = Shared.depthTracker.getLocalPOIAtom(controller.SelectUnproject[0]*(view2[2]),
										      controller.SelectUnproject[1]*(view2[3]))[2]
					eye1[0] =  controller.SelectUnproject[0]*(view2[2]) + view2[0]
					eye1[1] = controller.SelectUnproject[1]*(view2[3]) + view2[1]
					Model0 =  list(gluUnProject(eye0[0],eye0[1],eye0[2],\
									        Shared.ModelMatrixSet[0],Shared.ProjectMatrixSet[0],Shared.ViewportSet[0]))
					Model1 =  list(gluUnProject(eye1[0],eye1[1],eye1[2],\
									        Shared.ModelMatrixSet[1],Shared.ProjectMatrixSet[1],Shared.ViewportSet[1]))
					controller.SelectUnproject = [(Model0[0] + Model1[0])/2, (Model0[1] + Model1[1])/2, (Model0[2] + Model1[2])/2]
					if(eye1[2] == 1):
						controller.SelectUnproject = [-1,-1,-1]
				else:
					view2 = list(Shared.ViewportSet[1])
					eye1 = [0,0,0]
					eye1[2] = Shared.depthTracker.getLocalPOIAtom(controller.SelectUnproject[0]*(view2[2]),
										      controller.SelectUnproject[1]*(view2[3]))[2]
					eye1[0] =  controller.SelectUnproject[0]*(view2[2]) + view2[0]
					eye1[1] = controller.SelectUnproject[1]*(view2[3]) + view2[1]
					Model1 =  list(gluUnProject(eye1[0],eye1[1],eye1[2],\
									        Shared.ModelMatrixSet[1],Shared.ProjectMatrixSet[1],Shared.ViewportSet[1]))
					controller.SelectUnproject = Model1
					if(eye1[2] == 1):
						controller.SelectUnproject = [-1,-1,-1]




				controller.getSelectUnproject = 4
			if (controller.threed_cursor_modal_center == 1):
				controller.threed_cursor_modal_vector = list(gluUnProject(controller.threed_cursor_modal_vector[0],\
												  controller.threed_cursor_modal_vector[1],\
												  controller.threed_cursor_modal_vector[2]))
				controller.threed_cursor_modal_center = 2

		a = glGetDoublev(GL_MODELVIEW_MATRIX)
		b = glGetDoublev(GL_PROJECTION_MATRIX)
		c = glGetIntegerv(GL_VIEWPORT)
		present = True
		if( len(Shared.ViewportSet[0]) == 1 and len(Shared.ViewportSet[1]) == 1):
			present = False
		elif ( len(Shared.ViewportSet[0]) == 1):
			testView = ( Shared.ViewportSet[1] == c )
			testProject = ( Shared.ProjectMatrixSet[1] == b ) 
			testModel = (Shared.ModelMatrixSet[1] == a )

			for i in testView:
				if( not i):
					present = False

			for i in testProject:
				for j in i:
					if(not j):
						present = False
								
			for i in testModel:
				for j in i:
					if( not j):
						present = False
		else:
			perhapsPresent = [True,True]
			for k in range(2):
				testView = ( Shared.ViewportSet[k] == c )
				testProject = ( Shared.ProjectMatrixSet[k] == b ) 
				testModel = (Shared.ModelMatrixSet[k] == a )

				for i in testView:
					if( not i):
						perhapsPresent[k] = False
				
				for i in testProject:
					for j in i:
						if(not j):
							perhapsPresent[k] = False
								
				for i in testModel:
					for j in i:
						if( not j):
							perhapsPresent[k] = False
			present = perhapsPresent[0] or perhapsPresent[1]
		if not (present):
			Shared.ViewportSet[0] = Shared.ViewportSet[1]
			Shared.ViewportSet[1] = c
			Shared.ModelMatrixSet[0] = Shared.ModelMatrixSet[1]
			Shared.ModelMatrixSet[1] = a
			Shared.ProjectMatrixSet[0] = Shared.ProjectMatrixSet[1]
			Shared.ProjectMatrixSet[1] = b
		#takes a picture of what we're seeing for the new bookmark
		if Shared.bms.getViewForBookmark:
			self.tempPixels=[]
			self.tempPixels = glReadPixels(0,0,int(width),int(height),GL_RGB,GL_FLOAT)
			Shared.bms.recorded_view_pics.append(self.tempPixels)
			Shared.bms.recorded_view_width.append(width)
			Shared.bms.recorded_view_height.append(height)
			Shared.bms.getViewForBookmark = False

		

		
		
		glMatrixMode(GL_PROJECTION)
		glPushMatrix()
		glLoadIdentity()
		glOrtho(0,width,0,height, -.5, -.045)

		glMatrixMode(GL_MODELVIEW)
		glPushMatrix()
		glLoadIdentity()
		
		
		
		
		# Define at the beginning the quad's width
		# (the height will be known later in function of what we wrote)
		quad_width = width/3.5
		
		#ref_size = width/100
		ref_size = width/130
		scale_text = ref_size/60.0

		glPushMatrix()
		glTranslatef(0,height-2*ref_size,0.48)
								# START BOOKMARK DISPLAY CODE
		if Shared.bms.showBookmarkDisp and len(Shared.bms.recorded_view_pics) >0:
			glPushMatrix()
			glTranslatef(0,-10*ref_size,0.0)
			glPushMatrix()
			
			this_index = Shared.bms.num_rec_view
			screen_number = Shared.bms.num_rec_view/(Shared.bms.max_height*Shared.bms.max_width)
			starting_index = screen_number*Shared.bms.max_height*Shared.bms.max_width
			finish_index = Shared.bms.total_rec_views - 1
			if( finish_index - starting_index > Shared.bms.max_height*Shared.bms.max_width - 1):
				finish_index = starting_index + Shared.bms.max_height*Shared.bms.max_width - 1
			number_rows = math.ceil(float(finish_index - starting_index + 1) / float(Shared.bms.max_width))
			row_quantity = []
			num_remain = finish_index - starting_index + 1
			rows_remain = number_rows
			for x in range(int(number_rows)):
				row_quantity.append(math.ceil(num_remain / rows_remain ))
				num_remain -= row_quantity[x]
				rows_remain -= 1
			# starting from the top and working down...
			standing_count = 0
			glTranslatef(0,-1*height *((Shared.bms.max_height + .5 - number_rows  + 1 - (number_rows - 1) * \
							    (.5 / (Shared.bms.max_height + 1)) ) / (Shared.bms.max_height *2 + 1) ),0)
			if(Shared.bookmarkScreenChanged):
				total = 0
				for x in range(int(number_rows)):
					for y in range(int(row_quantity[x])):
						glBindTexture(GL_TEXTURE_2D, Shared.bms.currentTextures[total])
#						glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE)
						glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, Shared.bms.recorded_view_width[starting_index + total],\
							     int(Shared.bms.recorded_view_height[starting_index + total]), 0,GL_RGB,GL_FLOAT,\
							     Shared.bms.recorded_view_pics[starting_index + total])
#						glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_FALSE)
						total += 1
				Shared.bookmarkScreenChanged = False
			for x in range(int(number_rows)):
				
				glMatrixMode(GL_PROJECTION)
				glPushMatrix()
				glLoadIdentity()
				glOrtho(0,width,0,height, -2, 0)

				glMatrixMode(GL_MODELVIEW)
				glPushMatrix()
				glTranslatef(width * ((Shared.bms.max_width + .5 - row_quantity[x] - (row_quantity[x] - 1) * \
							       (.5 / (Shared.bms.max_width + 1)) ) / (Shared.bms.max_width *2 + 1) ),0,1.1)
				for y in range(int(row_quantity[x])):
#					glRasterPos2i(0,0)
#					glPixelZoom( (1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) * width /\
#							     Shared.bms.recorded_view_width[starting_index + standing_count],\
#							     (1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) \
#							     * width / Shared.bms.recorded_view_width[starting_index + standing_count])
#					glDrawPixels(int(Shared.bms.recorded_view_width[starting_index + standing_count]),\
#							     int(Shared.bms.recorded_view_height[starting_index + standing_count]),\
#							     GL_RGB,GL_FLOAT, Shared.bms.recorded_view_pics[starting_index + standing_count])
#					glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
					glEnable(GL_TEXTURE_2D)
					glShadeModel(GL_FLAT)
					glBindTexture(GL_TEXTURE_2D, Shared.bms.currentTextures[standing_count])
#					glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
#					glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
#					glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST)
#					glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_TRUE)
					glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR)
					glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL)
#					gluBuild2DMipmaps( GL_TEXTURE_2D, 3, Shared.bms.recorded_view_width[starting_index + standing_count],\
#							     int(Shared.bms.recorded_view_height[starting_index + standing_count]),GL_RGB,GL_FLOAT,
#							     Shared.bms.recorded_view_pics[starting_index + standing_count])
#					glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, Shared.bms.recorded_view_width[starting_index + standing_count],\
#							     int(Shared.bms.recorded_view_height[starting_index + standing_count]), 0,GL_RGB,GL_FLOAT,\
#							     Shared.bms.recorded_view_pics[starting_index + standing_count])
					glBegin(GL_QUADS)
					glColor3f(1,1,1)
					glTexCoord2f(0.0, 0.0)
					glVertex2f(0,0)
					glTexCoord2f(0.0, 1.0)
					glVertex2f(0,(1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5))  * height )
					glTexCoord2f(1.0,1.0)
					glVertex2f((1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) * width,\
							   (1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5))  * height)
					glTexCoord2f(1.0,0)
					glVertex2f((1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) * width, 0)
					glEnd()
					glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, 9986)
				#	glEnable(GL_TEXTURE_2D)
#					glTexParameteri(GL_TEXTURE_2D, GL_GENERATE_MIPMAP, GL_FALSE)
					if(Shared.bms.num_rec_view == starting_index + standing_count):
						glBegin(GL_LINES)
						glColor3f(0,1,0)
						glVertex2f(-.01*width,-.01*height)
						glVertex2f(width *( (1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) + .01), -.01*height)
						
						glVertex2f(width *( (1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) + .01), -.01*height)
						glVertex2f(width *((1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) + .01),\
								   height * ((1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) + .01)* ( width /\
										     Shared.bms.recorded_view_width[starting_index + standing_count])/\
								                      (height / Shared.bms.recorded_view_height[starting_index + standing_count]))
						
						glVertex2f(width *( (1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) + .01),\
								   height * ((1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) + .01)* \
								   ( width / Shared.bms.recorded_view_width[starting_index + standing_count])/\
								   (height / Shared.bms.recorded_view_height[starting_index + standing_count]))
						glVertex2f(-.01*width, height * ((1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) + .01)* ( width /\
								   Shared.bms.recorded_view_width[starting_index + standing_count])/\
								     (height / Shared.bms.recorded_view_height[starting_index + standing_count]))
						
						glVertex2f(-.01*width, height * ((1.0 / (max([Shared.bms.max_width, Shared.bms.max_height]) + .5)) + .01)* \
								     ( width / Shared.bms.recorded_view_width[starting_index + standing_count])/\
								     (height / Shared.bms.recorded_view_height[starting_index + standing_count]))
						glVertex2f(-.01*width,-.01*height)
						glEnd()
					standing_count+=1
					#finally, move a bit, and draw another
					glTranslatef(width * ((1 + (.5 / (Shared.bms.max_width + 1)))/(Shared.bms.max_width + .5)), 0, 0)
					glShadeModel(GL_SMOOTH)
				glMatrixMode(GL_PROJECTION)
				glPopMatrix()

				glMatrixMode(GL_MODELVIEW)
				glPopMatrix()
				glTranslatef(0, -1.0 * height * ((1.0 + (0.5 / (Shared.bms.max_height + 1.0)))/(Shared.bms.max_height + 0.5)), 0)

			glPopMatrix()
			
			glPopMatrix()
		elif Shared.bms.showBookmarkDisp:
			Shared.bms.showBookmarkDisp = False
		glPopMatrix()
		glTranslatef(1.5*ref_size,1*ref_size,0.48)
		if(Shared.bms.showBookmarkDisp == False):
			#drawUsersLights(Shared.nbUsers,quad_width,ref_size,scale_text)
			

			# Draw the label for the current modes
			glColor3f(1.0,1.0,1.0)

			#glPushMatrix()
			glScalef(scale_text,scale_text,1.0)
			
			Utilities.drawLabel("Mode : " + Shared.mode )
			glScalef(1/scale_text, 1/scale_text, 1)
			#glPopMatrix()
			
			glTranslatef(ref_size,0.0,0.0)
			
			# Draw information about bookmarks
			num_rec = -1
			total_rec = 0
			space_arrows = 3*glutStrokeWidth(GLUT_STROKE_ROMAN,ord("0"))
			moved_from_mark = False
			
			mark_minus = "*"
			color_minus = [0.0,0.0,0.0]
			
			mark_cur = "*"
			color_cur = [0.0,0.0,0.0]
			
			mark_plus = "*"
			color_plus = [0.0,0.0,0.0]
			
			if Shared.bms.bookmark_mode == Shared.bms.mode_views:
				num_rec = Shared.bms.num_rec_view
				total_rec = Shared.bms.total_rec_views
				moved_from_mark = Shared.bms.moved_from_view
				
			elif Shared.bms.bookmark_mode == Shared.bms.mode_selections:
				num_rec = Shared.bms.num_rec_sel
				total_rec = len(Shared.bms.recorded_sel)
				moved_from_mark = Shared.bms.moved_from_sel
				
				
			# Previous Mark
			if total_rec == 0 or ((not moved_from_mark and num_rec < 1) \
									or (moved_from_mark and num_rec + 1 < 1)):
				color_minus = [1.0,0.0,0.0]
			else:
				color_minus = [1.0,1.0,1.0]
				if moved_from_mark:
					if Shared.bms.bookmark_mode == Shared.bms.mode_views:
						mark_minus = str(num_rec + 1)
					else:
						mark_minus = Shared.bms.recorded_sel[num_rec][1]+Shared.bms.recorded_sel[num_rec][2]
				else:
					if Shared.bms.bookmark_mode == Shared.bms.mode_views:
						mark_minus = str(num_rec)
					else:
						mark_minus = Shared.bms.recorded_sel[num_rec-1][1]+Shared.bms.recorded_sel[num_rec-1][2]
			
			
			# Current Mark
			if total_rec <= 0:
				color_cur = [1.0,0.0,0.0]
			else:
				color_cur = [0.0,1.0,0.0]
				if moved_from_mark:
					mark_cur = "-"
				else:
					if Shared.bms.bookmark_mode == Shared.bms.mode_views:
						mark_cur = str(num_rec + 1)
					else:
						mark_cur = Shared.bms.recorded_sel[num_rec][1]+Shared.bms.recorded_sel[num_rec][2]
					
					
			# Next Mark
			if num_rec + 1 < total_rec:
				if Shared.bms.bookmark_mode == Shared.bms.mode_views:
					mark_plus = str(num_rec + 2)
				else:
					mark_plus = Shared.bms.recorded_sel[num_rec+1][1]+Shared.bms.recorded_sel[num_rec+1][2]
					
				color_plus = [1.0,1.0,1.0]
			else:
				color_plus = [1.0,0.0,0.0]
						
			
			bookmark_head = Shared.bms.bookmark_mode + "(" + str(total_rec) + ") "
			
			size_head = 0
			for c in bookmark_head:
				size_head += glutStrokeWidth(GLUT_STROKE_ROMAN,ord(c))
			
			
			glColor3f(1.0,1.0,1.0)
			
			
			
			glPushMatrix()
			glPushMatrix()	
			glScalef(scale_text,scale_text,1.0)
			Utilities.drawLabel(bookmark_head)
			glPopMatrix()

			
			glTranslatef(size_head*scale_text,0.0,0.0)
			
			
			# Draw previous mark
			glPushMatrix()
			glScalef(scale_text,scale_text,1.0)
			glColor3f(color_minus[0],color_minus[1],color_minus[2])
			Utilities.drawLabel(mark_minus)
			size_minus = 0
			for c in mark_minus:
				size_minus += glutStrokeWidth(GLUT_STROKE_ROMAN,ord(c))
			glPopMatrix()

			glTranslatef(size_minus*scale_text + ref_size,0.0,0.0)
			
			
			# Draw arrow
			if total_rec == 0 or (num_rec < 1 and not moved_from_mark):
				glColor3f(1.0,0.0,0.0)
			else:
				glColor3f(0.0,1.0,0.0)
			
			glPushMatrix()
			glTranslatef(0.0,ref_size/4.0,0.0)
			glBegin(GL_TRIANGLES)
			glVertex2f(0.0,ref_size/2.0)
			glVertex2f(ref_size,ref_size)
			glVertex2f(ref_size,0.0)
			glEnd()
			glPopMatrix()

			#glTranslatef(space_arrows*scale_text + 2*ref_size,0.0,0.0)
			glTranslatef(2*ref_size,0.0,0.0)
			

			# Draw current mark
			glPushMatrix()
			glScalef(scale_text,scale_text,1.0)
			glColor3f(color_cur[0],color_cur[1],color_cur[2])
			Utilities.drawLabel(mark_cur)
			size_cur = 0
			for c in mark_cur:
				size_cur += glutStrokeWidth(GLUT_STROKE_ROMAN,ord(c))
			glPopMatrix()

			glTranslatef(size_cur*scale_text + ref_size,0.0,0.0)


			# Draw arrow
			if total_rec <= 0 or num_rec + 1 == total_rec:
				glColor3f(1.0,0.0,0.0)
			else:
				glColor3f(0.0,1.0,0.0)

			glPushMatrix()
			glTranslatef(0.0,ref_size/4.0,0.0)
			glBegin(GL_TRIANGLES)
			glVertex2f(0.0,0.0)
			glVertex2f(0.0,ref_size)
			glVertex2f(ref_size,ref_size/2.0)
			glEnd()
			glPopMatrix()

			#glTranslatef(space_arrows*scale_text + 2*ref_size,0.0,0.0)
			glTranslatef(2*ref_size,0.0,0.0)


			# Draw next mark
			glPushMatrix()
			glScalef(scale_text,scale_text,1.0)
			glColor3f(color_plus[0],color_plus[1],color_plus[2])
			Utilities.drawLabel(mark_plus)
			size_plus = 0
			for c in mark_plus:
				size_plus += glutStrokeWidth(GLUT_STROKE_ROMAN,ord(c))
			glPopMatrix()
			
			glColor3f(1,1,1)
			glPushMatrix()
			glTranslatef(ref_size*4.0,0.0,0.0)
			glScalef(scale_text,scale_text,1.0)
			if(Shared.select_mode == 0):
				Utilities.drawLabel("sel. Mode: Atom")
			if(Shared.select_mode == 1):
				Utilities.drawLabel("sel. Mode: Resi")
			if(Shared.select_mode == 2):
				Utilities.drawLabel("sel. Mode: Chain")
			if(Shared.select_mode == 3):
				Utilities.drawLabel("sel. Mode: Object")
			glPopMatrix()
			
			glColor3f(.5,.7,.5)
			if(Shared.lastSelected != None):
				glPushMatrix()
				glTranslatef(ref_size*30.0,0.0,0.0)
				glScalef(scale_text,scale_text,1.0)
				Utilities.drawLabel(Shared.lastSelected)
				glPopMatrix()



			glPopMatrix()
			
			
			glTranslatef(0.0,-ref_size,0.0)
			
			

			# Draw the background quad
			glTranslatef(-ref_size*14,0,0)
			
			glColor4f(0.2,0.2,0.2,.35)
			
			glBegin(GL_QUADS)
			glVertex2f(0.0,0.0)
			glVertex2f(0.0,ref_size*3.5)
			glVertex2f(width*1.1,ref_size*3.5)
			glVertex2f(width*1.1,0.0)
		
			glEnd()
			
			# Draw the edges
		#	glColor3f(0.0,1.0,0.0)
			
		#	glPushMatrix()
		#	glTranslatef(0.0,0.0,0.01)
			
		#	glBegin(GL_LINES)
		#	glVertex2f(0.0,0.0)
		#	glVertex2f(quad_width,0.0)
		#	glEnd()
			
		#	glBegin(GL_LINES)
		#	glVertex2f(quad_width,0.0)
		#	glVertex2f(quad_width,quad_height)
		#	glEnd()
			
			
			

		#	glPopMatrix()

		glMatrixMode(GL_PROJECTION)
		glPopMatrix()
		
		glMatrixMode(GL_MODELVIEW)
		glPopMatrix()

			
		if( Shared.bms.showBookmarkDisp and self.flipflop):
			glMatrixMode(GL_PROJECTION)
			glPushMatrix()
			glLoadIdentity()
			glOrtho(0,width,0,height, -.5, -.045)

			glMatrixMode(GL_MODELVIEW)
			glPushMatrix()
			glLoadIdentity()
			glTranslatef(0,0,0.1)
			glColor4f(0.5,0.5,0.5,.3)
			glBegin(GL_QUADS)
			glVertex2f(0,height)
			glVertex2f(width,height)
			glVertex2f(width,0)
			glVertex2f(0,0)
			glEnd()
			
			glMatrixMode(GL_PROJECTION)
			glPopMatrix()
			glMatrixMode(GL_MODELVIEW)
			glPopMatrix()
		glEnable(GL_LIGHTING)
		for i in Shared.callbackList:
			i.runCallback()
	def get_extent(self):
		return [[0,0,0],[0,0,0]]
	
		
		



def drawUsersLights(nbUsers, width, ref_size, scale_text):
	radius_disk = 1.5*ref_size
	
	# Define colors
	colorLights = []
	colorUsers = []
	
	for i in range(0, nbUsers):
		controller = None
		if (i < len(Shared.controller_list)):
			controller = Shared.controller_list[i]
		if (i >= len(Shared.controller_list)):
			colorLights.append([0.5,0.5,0.5])
		elif controller.master or Shared.busy:          
			colorLights.append([1.0,0.0,0.0])
		elif Shared.master_timedout:
			colorLights.append([1.0,0.8,0.0])
		else:
			colorLights.append([0.0,0.7,0.0])

		if not (controller == None):
			if controller.deviceindex == 0:
				colorUsers.append([1.0,1.0,0.0])
			elif controller.deviceindex == 1:
				colorUsers.append([0.0,1.0,1.0])
		else:
			colorUsers.append([1.0,1.0,1.0])
	
	glColor3f(1.0,1.0,1.0)
	glTranslatef(radius_disk*1.5,0.0,0.01)
		
	glPushMatrix()
	glScalef(scale_text,scale_text,1.0)
	Utilities.drawLabel("  Pointer")
	glPopMatrix()	
	
	glTranslatef(0,-2*radius_disk,0)
	
	for i in range(0,nbUsers):
		
		if i >= nbUsers/2:
			if i == nbUsers/2:
				glTranslatef(0.0,(nbUsers/2)*3*radius_disk,0.0)
				
			glPushMatrix()
			glTranslatef(width/2.0,0.0,0.0)
			
		# Draw the disks for the "user lights"
		glColor3f(colorLights[i][0],colorLights[i][1],colorLights[i][2])
		gluPartialDisk(gluNewQuadric(),0,radius_disk,30,30,0,360)
		
		# Draw the labels for the "user lights"
		glColor3f(colorUsers[i][0],colorUsers[i][1],colorUsers[i][2])
		
		glPushMatrix()
		glTranslatef(0.0,0.0,0.01)
		gluPartialDisk(gluNewQuadric(),radius_disk-radius_disk/5.0,radius_disk,30,30,0,360)
		glPopMatrix()

		
		glColor3f(1.0,1.0,1.0)
		glPushMatrix()
		
		glTranslatef(0.0,-radius_disk/1.25,0)
		glPushMatrix()
		glTranslatef(-radius_disk/2.5,radius_disk/4.0,0.01)
		glScalef(scale_text,scale_text,1.0)
		label = "%d" % (i+1)
		Utilities.drawLabel(label)
		glPopMatrix()
		
		
		glColor3f(colorUsers[i][0],colorUsers[i][1],colorUsers[i][2])
		glPushMatrix()
		glTranslatef(0.0,ref_size/2.0,0.0)
		glScalef(scale_text,scale_text,1.0)
		
		if i < len(Shared.controller_list):
			if Shared.controller_list[i].PointerEnabled():
				Utilities.drawLabel("  ON")
			else:
				Utilities.drawLabel("  OFF")
		else:
			Utilities.drawLabel("  OFF")
		
		glPopMatrix()
		glPopMatrix()
		
		glColor3f(1.0,1.0,1.0)
		
		if i >= nbUsers/2:
			glPopMatrix()
			
		glTranslatef(0,-3*radius_disk,0)
