import sys
import math
import threading
import time

import GenericDevice
import DeviceType

from cgkit import *

import Input_Function
import Shared
import re

from pymol import cmd

sys.path.append('./build/lib.win32-2.6')
#import WiimoteAPI	#precompiled API.

#import WiimoteState

#From the WiimoteAPI:
NOT_PRESSED		= 0
JUST_PRESSED	= 1
HELD			= 2
JUST_RELEASED	= 3



#a static variable for holding all wiimote states
wiimote_count = 0
wiimote_state = []


class XboxDevice(GenericDevice.GenericDevice):
 #Wiimote specific state variables.
	joystick = None
	prevPointerPos1 = 0
	prevPointerPos2 = 0
	index = 0
	pointing = True
	selectionExists = False
	placing_cursor = False

	acc_nav_state = [0,0,0]
	prev_accelerometer_navigation = [0,0,0]
	
	threed_cursor_visible = False
	threed_cursor_coords = [0,0,0]
	threed_cursor_resi_coords = [0,0,0]
	threed_cursor_resi = None
	threed_cursor_getUnProject = False
	threed_get_ray = False
	threed_ray = [[0,0,0],[0,0,0]]
	threed_cursor_size = 5
	threed_cursor_disturbed = False
	threed_cursor_res_array = []
	threed_cursor_res_index = 0
	threed_cursor_state = 0
	threed_cursor_moved = False
	threed_cursor_style = "cartoon"
	
	threed_cursor_snapping = False
	
	threed_cursor_selecting = 1
	threed_cursor_final = False
	
	threed_cursor_atom = 0
	threed_cursor_atom_name = None
	
	threed_cursor_origin_store_m = [0,0,0]
	threed_cursor_origin_store_c = [0,0,0]
	
	accelerometer_view = None

	acceleration_pointing =False
	accel_time_weight = 1
	is_move_accelerating  = False
	startmovetime = 0
	lastActed = 0
	
	getSelectUnproject = 0
	SelectUnproject = [0,0,0]
	
	cursorMode = False
	lastTrans = None
	lastDist0 = 0
	lastDist1 = 0
	pointer_position = [0,0]
	
	finalList = []
	finalSpans = []
	threed_cursor_view_mat = []
	pointerOn = True
	
 #Generic Device Methods
	def __init__(self, index, xboxindex):
		self.joystick = pygame.joystick.Joystick(xboxindex)
		device_type = DeviceType.DEVICE_XBOX
		GenericDevice.GenericDevice.__init__(self, index)
		Shared.bms.bookmark_mode = Shared.bms.mode_views
		Input_Function.CreateBookmarkView(self)
		print "Hello"
		self.lastFrameBeat = time.clock()
		self.lastFrameBeatController = time.clock()
		self.pointer_position = [0,0]
		self.previousJoystickState =  [ self.joystick.get_axis(0),
						self.joystick.get_axis(1),
						self.joystick.get_axis(2),
						self.joystick.get_axis(3),
						self.joystick.get_axis(4),
						self.joystick.get_axis(5),
						self.joystick.get_button(0),
						self.joystick.get_button(1),
						self.joystick.get_button(2),
						self.joystick.get_button(3),
						self.joystick.get_button(4),
						self.joystick.get_button(5),
						self.joystick.get_button(6),
						self.joystick.get_button(7),
						self.joystick.get_button(8),
						self.joystick.get_button(9),
						self.joystick.get_button(10),
						self.joystick.get_button(11),
						self.joystick.get_button(12),
						self.joystick.get_button(13),
						self.joystick.get_button(14)]

		index = xboxindex

	def HandleInput(self):
		frameRate = 0
		if(self.lastFrameBeat > time.clock()):
			frameRate = 1 / (self.lastFrameBeat - time.clock())
		else:
			frameRate = 10
		frameScale = 1#30 / frameRate
		self.lastFrameBeat = time.clock()
		#A couple state based things.....		
		modecount = 0
		rotate = True        #In default mode, we're rotating with the nunchuck
		translate = False
		zoom = False
		acted = False
		
		selectionMoveMode = False
		normalMode = not self.cursorMode
		currentJoystickState=  [ self.joystick.get_axis(0),
					 self.joystick.get_axis(1),
					 self.joystick.get_axis(4) - self.joystick.get_axis(5),
					 self.joystick.get_axis(3),
					 self.joystick.get_axis(2),
					 self.joystick.get_button(11),
					 self.joystick.get_button(12),
					 self.joystick.get_button(13),
					 self.joystick.get_button(14),
					 self.joystick.get_button(8),
					 self.joystick.get_button(9),
					 self.joystick.get_button(5),
					 self.joystick.get_button(4),
					 self.joystick.get_button(6),
					 self.joystick.get_button(7),
					 self.joystick.get_button(3) - self.joystick.get_button(2),
					 self.joystick.get_button(0) - self.joystick.get_button(1)]



								
								
		if (math.fabs(currentJoystickState[0]) < .15 ):
			currentJoystickState[0] = 0
		if (math.fabs(currentJoystickState[1]) < .15 ):
			currentJoystickState[1] = 0
		if (math.fabs(currentJoystickState[2]) < .05 ):
			currentJoystickState[2] = 0
		if (math.fabs(currentJoystickState[3]) < .15 ):
			currentJoystickState[3] = 0
		if (math.fabs(currentJoystickState[4]) < .15 ):
			currentJoystickState[4] = 0
			
		if (currentJoystickState[5] == 1 and self.previousJoystickState[5] == 0 and not Shared.bms.showBookmarkDisp):
			normalMode = self.cursorMode
			self.cursorMode = not self.cursorMode
			if(normalMode):
				if( "WM_Sel" in cmd.get_names("selections")):
					cmd.enable("WM_Sel")
			modecount += 1
			self.threed_cursor_final
			Shared.hide_pointers = False
			print self.cursorMode
				
			
		#These two can be held down at any time during the "different" modes to modify nunchuck axis functions
		if (currentJoystickState[2] >= .3):
			zoom = False
			translate = True 
			rotate = False
			
		view = cmd.get_view();
		if (currentJoystickState[2] <= -.3):
			self.threed_cursor_origin_store_m = [view[12],view[13],view[14]]
			self.threed_cursor_origin_store_c = [view[9],view[10],view[11]]
			

		if (currentJoystickState[9] == 1):
			zoom = True
			translate = False  #just to avoid the Z + C issue
			rotate = False
			
		#We don't want to deal with mashing multiple buttons at once and confuzoring ourselves.
		if (modecount > 1):
			return
					

		#Axis bindings:
		[sum, distX, distY] = [math.sqrt(math.pow(currentJoystickState[0],2) + math.pow(currentJoystickState[1], 2)), 
								currentJoystickState[0], -1 * currentJoystickState[1]]
		if (sum > 0) or self.cursorMode or Shared.Molecule_moving:
			Shared.Molecule_moving = True
		else:
			Shared.Molecule_moving = False
		if (sum > 0) and (not Shared.master_exists or self.master):		
			if(not self.moving_molecule):
				Shared.getAPOI = True
				self.moving_molecule = True
				
			view = cmd.get_view()
			scale_factor = math.sqrt(math.pow(Shared.depthTracker.realSpacePOI[0] - view[12] + view[9],2) + \
							math.pow(Shared.depthTracker.realSpacePOI[1] - view[13] + view[10],2) + \
							math.pow(Shared.depthTracker.realSpacePOI[2] - view[14] + view[11],2))
			if not self.is_move_accelerating:
				self.is_move_accelerating = True
				self.startmovetime = time.clock()

			if (normalMode or self.cursorMode):
				if (translate):
					Input_Function.Translate(self, "XY", distX * frameScale * sum * scale_factor / 500, distY * sum * scale_factor / 500)					
				if (zoom):
					Input_Function.Translate(self, "Z", -1 * distY * frameScale * sum * scale_factor / 500, -1 * distY * sum * scale_factor / 500)					
				if (rotate):
					[angleX, angleY] = self.GetRotation(sum, distX, distY)
					Input_Function.Rotate(self, angleX * frameScale * scale_factor / 500, angleY * frameScale * scale_factor / 500)				
					
			if (selectionMoveMode):
				if (translate):
					#Translate a selection in XY plane
					pass
				if (zoom):
					#Translate a selection on Z axis
					pass
				if (rotate):
					#Rotate a selection
					pass

			
			acted = True
		else:
			self.is_move_accelerating = False
			self.moving_molecule = False

	


		#Bookmark delete
		if (currentJoystickState[11] == 1 and self.previousJoystickState[11] == 0):			
			Input_Function.DeleteBookmarkView(self)
			acted = True
		
		#Bookmark add
   		if (currentJoystickState[12] == 1 and self.previousJoystickState[12] == 0):
			Input_Function.CreateBookmarkView(self)
			acted = True

		#Bookmark viewer
		if (currentJoystickState[8] == 1 and self.previousJoystickState[8] == 0):
			Input_Function.ToggleBookmarkView(self)			
			acted = True

		#select mode up or Bookmark Viewer navigation
		if (currentJoystickState[16] == 1 and self.previousJoystickState[16] == 0):			
			Input_Function.SelectModeUp(self)
			Input_Function.movViewUp(self)
			acted = True

		#Select mode down or viewer navigation
		if (currentJoystickState[16] == -1 and self.previousJoystickState[16] == 0):
			
			Input_Function.SelectModeDown(self)
			Input_Function.movViewDown(self)
			acted = True
			
		#selection right/left
		if (currentJoystickState[15] == 1 and self.previousJoystickState[15] == 0 and not self.cursorMode):
			
			Input_Function.movViewRight(self)
			acted = True
		#selection right/left
		if (currentJoystickState[15] == -1 and self.previousJoystickState[15] == 0 and not self.cursorMode):
			
			Input_Function.movViewLeft(self)
			acted = True

		#Prep the unproject stuff in CGUI
		if (currentJoystickState[5] == 1 and self.previousJoystickState[5] == 0) and normalMode and Shared.bms.showBookmarkDisp:
			Input_Function.MoveToBookmark(self)
			
		if(not Shared.bms.showBookmarkDisp and currentJoystickState[10] == 1 and self.previousJoystickState[10] == 0
				and not self.cursorMode):
				self.getSelectUnproject = 1
				self.selectionExists = True
				Shared.hide_pointers = True
				cmd.enable("WM_Sel")
				if(Shared.CurrentSelection != 0):
					Shared.CurrentSelection = 0
					Input_Function.refreshSelection(False)
			
			
		all_pointers_hidden = True
		for i in Shared.pointers_hidden:
			if not i :
				all_pointers_hidden = False		
				
		if( all_pointers_hidden and self.getSelectUnproject == 1):
			Shared.get_a_new_buffer = True
			self.getSelectUnproject = 2
			
		if (self.getSelectUnproject == 2 and not Shared.get_a_new_buffer):
			temp = self.GetPointerPosition()
			temp = [temp[0] * Shared.viewport[2],
					temp[1] * Shared.viewport[3]]
			if(Shared.select_mode == 0):
				self.SelectUnproject = Shared.depthTracker.getLocalPOIAtom(temp[0],temp[1])
			else:
				self.SelectUnproject = Shared.depthTracker.getLocalPOI(temp[0],temp[1])
			if (self.SelectUnproject[2] == 1):
				cmd.select("WM_Sel","none")
				cmd.enable("WM_Sel")
				self.getSelectUnproject = 0
				acted = True
			else:
				self.getSelectUnproject = 3
				acted = True
			Shared.hide_pointers = False


		#Use the result from CGUI
		if (self.getSelectUnproject == 4):
			if self.PointerEnabled():
				Input_Function.Select(self,self.SelectUnproject)
			self.getSelectUnproject = 0
			
		
						
		#This is the 3D selector option
		
		#Start 3D Cursor
	#	if (not self.PointerEnabled() and self.cursorMode):
	#		self.threed_cursor_visible = False
	#		cmd.delete("Threed_cursor_insides")
	#		self.cursorMode = False
	#		normalMode = True
			
		if (self.cursorMode and self.PointerEnabled() and currentJoystickState[5] == 1 and self.previousJoystickState[5] == 0):
			self.threed_cursor_visible = True
			Shared.hide_pointers = True
			self.threed_cursor_atom_name = None
			self.threed_cursor_moved = False
			self.threed_cursor_selecting = 1
			self.threed_cursor_state = 1
		
		all_pointers_hidden = True
		for i in Shared.pointers_hidden:
			if not i :
				all_pointers_hidden = False
				
		if (self.threed_cursor_state == 1 and all_pointers_hidden):
			Shared.get_a_new_buffer = True
			self.threed_cursor_state = 2
		
		if (self.threed_cursor_state == 2 and not Shared.get_a_new_buffer):
 			if(Input_Function.SendCursor(self)):
		 		self.threed_cursor_state = 3
	 			self.threed_get_ray = True
				self.threed_cursor_disturbed = True 			
				acted = True
				self.placing_cursor = True
			else:
				self.threed_cursor_state = 0
				Shared.hide_pointers = False
				self.threed_cursor_visible = False
				acted = True
				cmd.disable("Threed_cursor_insides" + str(self.index))
				self.cursorMode = False
				normalMode = True
				self.threed_cursor_resi = None
		#		else:
		#			Shared.hide_pointers = False
		#			self.threed_cursor_state = 0
		
		if(self.threed_cursor_state == 3) and not self.threed_get_ray:
				self.threed_cursor_resi_coords[0] = self.threed_cursor_coords[0]
				self.threed_cursor_resi_coords[1] = self.threed_cursor_coords[1]
				self.threed_cursor_resi_coords[2] = self.threed_cursor_coords[2]
				self.threed_cursor_disturbed = True
				self.threed_cursor_visible = True
				self.threed_cursor_final = True
				self.threed_cursor_moved = True
				self.threed_cursor_state = 4
		
		#Continue 3D Cursor
		[distX2,distY2,sum2] = [currentJoystickState[4],-1 * currentJoystickState[3], 
					math.sqrt(math.pow(currentJoystickState[3],2) +  math.pow(currentJoystickState[4],2))]
		threed_xy = False
		threed_size = False
		threed_z = True
		if currentJoystickState[2] <= -.3 :
			threed_xy = True
			threed_z = False
			print threed_xy
		if currentJoystickState[10] == 1 :
			threed_size = True
			threed_z = False
		if self.cursorMode and (self.threed_cursor_state == 4 or self.threed_cursor_state == 0) :	
			if(self.threed_cursor_selecting == 1):
				if not (zoom or translate) and sum2 > .03:
					self.threed_cursor_moved = True
					if(threed_z):
						vectorAmount = Input_Function.MatMult([view[0],view[1],view[2],
														   view[3],view[4],view[5],
														   view[6],view[7],view[8]],[0,0,-1 * distY2*sum2 * 1.5])
						self.threed_cursor_coords[0] +=vectorAmount[0]
						self.threed_cursor_coords[1] +=vectorAmount[1]
						self.threed_cursor_coords[2] +=vectorAmount[2]
						self.threed_cursor_disturbed = True
						self.threed_cursor_resi_coords[0] = self.threed_cursor_coords[0]
						self.threed_cursor_resi_coords[1] = self.threed_cursor_coords[1]
						self.threed_cursor_resi_coords[2] = self.threed_cursor_coords[2]
						self.threed_cursor_resi = None
					elif(threed_xy):
						vectorAmount = Input_Function.MatMult([view[0],view[1],view[2],
														   view[3],view[4],view[5],
														   view[6],view[7],view[8]],[distX2*sum2 * 1.5,distY2*sum2*1.5,0.0])
						self.threed_cursor_coords[0] +=vectorAmount[0]
						self.threed_cursor_coords[1] +=vectorAmount[1]
						self.threed_cursor_coords[2] +=vectorAmount[2]
						print self.threed_cursor_coords
						self.threed_cursor_disturbed = True
						self.threed_cursor_resi_coords[0] = self.threed_cursor_coords[0]
						self.threed_cursor_resi_coords[1] = self.threed_cursor_coords[1]
						self.threed_cursor_resi_coords[2] = self.threed_cursor_coords[2]
						self.threed_cursor_resi = None
					elif(threed_size):
						self.threed_cursor_size += .1*distY2*sum2
						print "size : " + str(self.threed_cursor_size) + "Angstroms"
				if(self.threed_cursor_resi != None):
					#cmd.delete("Threed_cursor_insides" + str(self.index))
					cmd.select("Threed_cursor_insides" + str(self.index),"all within " + str(float(self.threed_cursor_size)) + " of " + str(self.threed_cursor_resi))
					cmd.enable("Threed_cursor_insides" + str(self.index))
					self.threed_cursor_disturbed = True
					self.threed_cursor_resi_coords[0] = self.threed_cursor_coords[0]
					self.threed_cursor_resi_coords[1] = self.threed_cursor_coords[1]
					self.threed_cursor_resi_coords[2] = self.threed_cursor_coords[2]
			elif(self.threed_cursor_atom_name != None):
				extents = Shared.Extent_Dictionary[self.threed_cursor_resi + "/" + str(self.threed_cursor_atom_name)]
				self.threed_cursor_resi_coords = extents[0]
				if (sum2 > 0 and threed_size):
					self.threed_cursor_size += .1*distY2*sum2
					if(distY2 != 0):
						print "size : " + str(self.threed_cursor_size) + "Angstroms"
				if(self.threed_cursor_resi != None):
					cmd.select("Threed_cursor_insides" + str(self.index),"all within " + str(float(self.threed_cursor_size)) + " of " + str(self.threed_cursor_resi) + "/" + self.threed_cursor_atom_name)
					cmd.enable("Threed_cursor_insides" + str(self.index))
			self.threed_cursor_state = 0
			acted = True
			
		if currentJoystickState[13] == 1 and self.previousJoystickState[13] == 0 and not translate and not zoom: 
			self.threed_cursor_visible = not self.threed_cursor_visible
		
			
			
		if currentJoystickState[15] == 1 and self.previousJoystickState[15] == 0 and normalMode and Shared.CurrentSelection == 0 and self.selectionExists: 
			cmd.select("WM_Sel" + str(Shared.SelectionCount + 1), "WM_Sel")
			cmd.select("WM_Sel", "none")
			cmd.enable("WM_Sel")
			cmd.disable("WM_Sel" + str(Shared.SelectionCount + 1))
			Shared.SelectionCount+=1
			Shared.CurrentSelection = 0
			Input_Function.refreshSelection(True)
			
		elif(currentJoystickState[15] == 1 and self.previousJoystickState[15] == 0 and normalMode and self.selectionExists):
			for i in range(Shared.SelectionCount - Shared.CurrentSelection ) : 
				cmd.select("WM_Sel" + str(i + Shared.CurrentSelection), "WM_Sel" + str(i + 1 + Shared.CurrentSelection))
			cmd.delete("WM_Sel" + str(Shared.SelectionCount))
			Shared.SelectionCount-=1
			Shared.CurrentSelection = 0
			Input_Function.refreshSelection(True)
			

		if (self.cursorMode and currentJoystickState[15] == -1 and self.previousJoystickState[15] == 0):
			if(self.threed_cursor_selecting == 1 and self.threed_cursor_resi != None):
				print "residue locked"
				self.threed_cursor_selecting = 0
				a = re.compile('/[^/]*')
				regexp = a.findall(self.threed_cursor_resi)
				b = re.compile('[^/]*')
				self.threed_cursor_atom_name = Shared.Resi_Dictionary[b.findall(regexp[0])[1]][b.findall(regexp[2])[1]][b.findall(regexp[3])[1]][self.threed_cursor_atom]
				print "snapped to " + self.threed_cursor_resi + "/" + self.threed_cursor_atom_name
			else:
				print "residue unlocked"
				self.threed_cursor_selecting = 1
				self.threed_cursor_atom_name = None
				self.threed_cursor_atom = 0
				
		if (self.cursorMode and currentJoystickState[15] == 1 and self.previousJoystickState[15] == 0 and self.threed_cursor_selecting == 0  and self.threed_cursor_resi != None):
			self.threed_cursor_atom+=1
			a = re.compile('/[^/]*')
			regexp = a.findall(self.threed_cursor_resi)
			b = re.compile('[^/]*')
			if(self.threed_cursor_atom >= len(Shared.Resi_Dictionary[b.findall(regexp[0])[1]][b.findall(regexp[2])[1]][b.findall(regexp[3])[1]])):
				self.threed_cursor_atom = 0			
			self.threed_cursor_atom_name = Shared.Resi_Dictionary[b.findall(regexp[0])[1]][b.findall(regexp[2])[1]][b.findall(regexp[3])[1]][self.threed_cursor_atom]
			print "snapped to " + self.threed_cursor_resi + "/" + self.threed_cursor_atom_name
			

		if(currentJoystickState[15] == -1 and self.previousJoystickState[15] == 0 and normalMode):
			Shared.CurrentSelection -= 1
			if(Shared.CurrentSelection < 0):
				Shared.CurrentSelection = Shared.SelectionCount
			Input_Function.refreshSelection(True)
						
		if (self.cursorMode and currentJoystickState[7] == 1 and self.previousJoystickState[7] == 0):
			if(self.threed_cursor_style == "cartoon"):
				self.threed_cursor_style = "sticks"
			elif(self.threed_cursor_style == "sticks"):
				self.threed_cursor_style = "dots"
			elif(self.threed_cursor_style == "dots"):
				self.threed_cursor_style = "surface"
			elif(self.threed_cursor_style == "surface"):
				self.threed_cursor_style = "lines"
			elif(self.threed_cursor_style == "lines"):
				self.threed_cursor_style = "spheres"
			elif(self.threed_cursor_style == "spheres"):
				self.threed_cursor_style = "mesh"
			elif(self.threed_cursor_style == "mesh"):
				self.threed_cursor_style = "ribbon"
			elif(self.threed_cursor_style == "ribbon"):
				self.threed_cursor_style = "cartoon"
			if(self.threed_cursor_selecting == 1):
				cmd.show_as(self.threed_cursor_style, "all within " + str(float(self.threed_cursor_size)) + " of " + str(self.threed_cursor_resi))
			else:
				cmd.show_as(self.threed_cursor_style, "all within " + str(float(self.threed_cursor_size)) + " of " + str(self.threed_cursor_resi + "/" + self.threed_cursor_atom_name))
		
		if (currentJoystickState[7] == 1 and self.previousJoystickState[7] == 0 and not self.cursorMode):
			if(self.threed_cursor_style == "cartoon"):
				self.threed_cursor_style = "sticks"
			elif(self.threed_cursor_style == "sticks"):
				self.threed_cursor_style = "dots"
			elif(self.threed_cursor_style == "dots"):
				self.threed_cursor_style = "surface"
			elif(self.threed_cursor_style == "surface"):
				self.threed_cursor_style = "lines"
			elif(self.threed_cursor_style == "lines"):
				self.threed_cursor_style = "spheres"
			elif(self.threed_cursor_style == "spheres"):
				self.threed_cursor_style = "mesh"
			elif(self.threed_cursor_style == "mesh"):
				self.threed_cursor_style = "ribbon"
			elif(self.threed_cursor_style == "ribbon"):
				self.threed_cursor_style = "cartoon"
			if( "WM_Sel" in cmd.get_names("selections")):
				cmd.show_as(self.threed_cursor_style, "WM_Sel")
						
		if (self.cursorMode and currentJoystickState[6] == 1 and self.previousJoystickState[6] == 0):
			if(self.threed_cursor_style == "sticks"):
				self.threed_cursor_style = "cartoon"
			elif(self.threed_cursor_style == "dots"):
				self.threed_cursor_style = "sticks"
			elif(self.threed_cursor_style == "surface"):
				self.threed_cursor_style = "dots"
			elif(self.threed_cursor_style == "lines"):
				self.threed_cursor_style = "surface"
			elif(self.threed_cursor_style == "spheres"):
				self.threed_cursor_style = "lines"
			elif(self.threed_cursor_style == "mesh"):
				self.threed_cursor_style = "spheres"
			elif(self.threed_cursor_style == "ribbon"):
				self.threed_cursor_style = "mesh"
			elif(self.threed_cursor_style == "cartoon"):
				self.threed_cursor_style = "ribbon"
			if(self.threed_cursor_selecting == 1):
				cmd.show_as(self.threed_cursor_style, "all within " + str(float(self.threed_cursor_size)) + " of " + str(self.threed_cursor_resi))
			else:
				cmd.show_as(self.threed_cursor_style, "all within " + str(float(self.threed_cursor_size)) + " of " + str(self.threed_cursor_resi + "/" + self.threed_cursor_atom_name))

		if (currentJoystickState[6] == 1 and self.previousJoystickState[6] == 0 and not self.cursorMode):
			if(self.threed_cursor_style == "sticks"):
				self.threed_cursor_style = "cartoon"
			elif(self.threed_cursor_style == "dots"):
				self.threed_cursor_style = "sticks"
			elif(self.threed_cursor_style == "surface"):
				self.threed_cursor_style = "dots"
			elif(self.threed_cursor_style == "lines"):
				self.threed_cursor_style = "surface"
			elif(self.threed_cursor_style == "spheres"):
				self.threed_cursor_style = "lines"
			elif(self.threed_cursor_style == "mesh"):
				self.threed_cursor_style = "spheres"
			elif(self.threed_cursor_style == "ribbon"):
				self.threed_cursor_style = "mesh"
			elif(self.threed_cursor_style == "cartoon"):
				self.threed_cursor_style = "ribbon"
			if( "WM_Sel" in cmd.get_names("selections")):
				cmd.show_as(self.threed_cursor_style, "WM_Sel")
				
		
		
		if (self.threed_cursor_visible and self.cursorMode and not self.threed_cursor_getUnProject and 
				self.threed_cursor_resi == None and self.threed_cursor_selecting == 1 and self.threed_cursor_final and sum2 == 0):
			self.threed_cursor_resi = Input_Function.getResiToSnap(self)
				
		if (self.threed_cursor_visible and self.cursorMode and not self.threed_cursor_getUnProject and 
				self.threed_cursor_resi != None and self.threed_cursor_selecting == 1 and self.threed_cursor_final and 
				currentJoystickState[14] == 1 and self.previousJoystickState[14] == 0):
			Input_Function.SnapToResiCursor(self)
			self.threed_cursor_coords = self.threed_cursor_resi_coords
			
			
			
		

			
		if (acted == True):
			self.lastActed = time.clock()
		
		self.previousJoystickState = currentJoystickState
		self.GetPointerPosition()
		if(time.clock() - self.lastActed > Shared.time_for_master and self.master):
			Input_Function.ToggleMaster(self)
			Shared.master_exists = False




	def AlertMasterFree(self):
		if self.master != True:
#			WiimoteAPI.Rumble(self.index,500)
			pass

	def PointerEnabled(self):
		return self.pointerOn

	def GetPointerPosition(self):
		if(not self.cursorMode):
			#Either using acceleration pointing or just regular laser pointing.
			#Need to be able to see both dots to update
			if (self.previousJoystickState[14] == 1 and len(Shared.viewport) > 0):
				print "centered cursor"
				self.pointer_position = [.5, .5]
				return 	self.pointer_position
				
			if (self.PointerEnabled() and len(Shared.viewport) > 0):
				#print "."
				minX = Shared.viewport[0]
				maxX = Shared.viewport[2]
				minY = Shared.viewport[1]
				maxY = Shared.viewport[3]
				xC = self.pointer_position[0] * maxX + minX
				yC = self.pointer_position[1] * maxY + minY
				cursorSum = math.sqrt(math.pow(self.previousJoystickState[4],2) + math.pow(self.previousJoystickState[3],2))
				xCursor = xC + self.previousJoystickState[4] * 350 * math.pow(cursorSum, 3) * (time.clock() - self.lastFrameBeatController)
				yCursor = yC - self.previousJoystickState[3] * 350 * math.pow(cursorSum, 3) * (time.clock() - self.lastFrameBeatController)
				self.lastFrameBeatController = time.clock()
				
				self.pointer_position[1] = ((yCursor - minY) /(1.0*maxY))
				self.pointer_position[0] = ((xCursor - minX) /(1.0*maxX))

				return 	self.pointer_position
		
		return [0,0]


#Wiimote Specific Functions here:


	def CalculateNunchuk(self):
		sum = abs(pow(self.button_state.xNunchuk,2) + pow(self.button_state.yNunchuk,2))
		if (sum != 0):
			#Calculate translational stuff. From yoram's original calculations
			xJnorm = self.button_state.xNunchuk/pow(sum,0.5)
			yJnorm = self.button_state.yNunchuk/pow(sum,0.5)

			#This gets the size of the molecule and modifies our distance equations to deal with its speed.
			#extent = cmd.get_extent()
			#size = pow(pow(extent[1][0]-extent[0][0],2)+pow(extent[1][1]-extent[0][1],2)+pow(extent[1][2]-extent[0][2],2),0.5)
			#step = (math.log(size)/4.0)*sum

			#distX = pow(step,2)*xJnorm
			#distY = pow(step,2)*yJnorm
			distX = xJnorm
			distY = yJnorm
			return [sum, distX, distY]
		return [0, 0, 0]

	def GetRotation(self, sum, xJnorm, yJnorm): #X direction is rotate around Y, etc...
		angleX = pow(sum*3,2)*yJnorm
		angleX_rad = (angleX*math.pi)/180
		angleY = -pow(sum*3,2)*xJnorm
		angleY_rad = (angleY*math.pi)/180
		return [angleX_rad, angleY_rad]
		
	
