import Utilities
import math

from pymol import cmd
from pymol.callback import Callback
from pymol.opengl.gl import *
from pymol.opengl.glu import *
from pymol.opengl.glut import *

import time

import Shared


class Cameras:
	visible=True
	def runCallback(self):
		glEnable(GL_BLEND)
		glDisable(GL_LIGHTING)
		
		# GUI
		if(not Shared.bms.getViewForBookmark):
			glColor4f(0,1,1,.3)
			currentview = cmd.get_view()
			currentProper = []
			for a in range(16):
				currentProper.append(0)
			#because the view matrix in pymol is stored in the inverse of the intuitive matrix, we have to invert the rotation matrix.
			# Luckily, rotation matrices are orthoganal, so there really isn't a lot of work that needs to be done, just taking the 
				#transposed matrix.
			currentProper[0] = currentview[0]
			currentProper[4] = currentview[1]
			currentProper[8] = currentview[2]
			currentProper[1] = currentview[3]
			currentProper[5] = currentview[4]
			currentProper[9] = currentview[5]
			currentProper[2] = currentview[6]
			currentProper[6] = currentview[7]
			currentProper[10] = currentview[8]
			currentProper[15] = 1
			self.extent = currentview[12:15]
			
			for x in range(Shared.bms.total_rec_views):
				glPushMatrix()
				#glLoadIdentity()
				proper_Mat = []
				for a in range(16):
					proper_Mat.append(0)
				proper_Mat[0] = Shared.bms.recorded_views[x][0]
				proper_Mat[4] = Shared.bms.recorded_views[x][1]
				proper_Mat[8] = Shared.bms.recorded_views[x][2]
				proper_Mat[1] = Shared.bms.recorded_views[x][3]
				proper_Mat[5] = Shared.bms.recorded_views[x][4]
				proper_Mat[9] = Shared.bms.recorded_views[x][5]
				proper_Mat[2] = Shared.bms.recorded_views[x][6]
				proper_Mat[6] = Shared.bms.recorded_views[x][7]
				proper_Mat[10] = Shared.bms.recorded_views[x][8]

				proper_Mat[15] = 1
				#glTranslatef(currentview[9],
				#					currentview[10],
				#					currentview[11])
				#glMultMatrix(currentProper)
				glTranslatef(Shared.bms.recorded_views[x][12],Shared.bms.recorded_views[x][13],Shared.bms.recorded_views[x][14])
				glMultMatrixf(proper_Mat)
				glTranslatef(-1*Shared.bms.recorded_views[x][9]/2,
								-1*Shared.bms.recorded_views[x][10]/2,
								-1*Shared.bms.recorded_views[x][11]/2)
				scale = math.sqrt(Shared.bms.recorded_views[x][9] * Shared.bms.recorded_views[x][9] + Shared.bms.recorded_views[x][10] * Shared.bms.recorded_views[x][10] + Shared.bms.recorded_views[x][11] * Shared.bms.recorded_views[x][11]) /30
				glBegin(GL_TRIANGLES)
				glColor4f(0,1,1,.3)
				if x == Shared.bms.num_rec_view:
					glColor4f(1,0,0,.3)
				glVertex3f(1*scale,1*scale,0.0)
				glVertex3f(-1*scale,1*scale,0.0)
				glColor4f(0,0,0,0)
				glVertex3f(0.0,0.0,1*scale)
				
				glColor4f(0,1,1,.3)
				if x == Shared.bms.num_rec_view:
					glColor4f(1,0,0,.3)
				glVertex3f(1*scale,1*scale,0.0)
				glVertex3f(1*scale,-1*scale,0.0)
				glColor4f(0,0,0,0)
				glVertex3f(0.0,0.0,1*scale)
				
				glColor4f(0,1,1,.3)
				if x == Shared.bms.num_rec_view:
					glColor4f(1,0,0,.3)
				glVertex3f(-1*scale,-1*scale,0.0)
				glVertex3f(1*scale,-1*scale,0.0)
				glColor4f(0,0,0,0)
				glVertex3f(0.0,0.0,1*scale)
				
				glColor4f(0,1,1,.3)
				if x == Shared.bms.num_rec_view:
					glColor4f(1,0,0,.3)
				glVertex3f(-1*scale,-1*scale,0.0)
				glVertex3f(-1*scale,1*scale,0.0)
				glColor4f(0,0,0,0)
				glVertex3f(0.0,0.0,1*scale)
				
				glEnd()
				glPopMatrix()
		glEnable(GL_LIGHTING)
	def get_extent(self):
		return [[0,0,0],[0,0,0]]
