#include "stdafx.h"

#include <Python.h>
#include "PointerOverlay.h"

#include <iostream>

static PyObject* PointerModule_Init(PyObject* self, PyObject* args)
{
	PyObject* pointer0;
	PyObject* pointer1;
	PyArg_ParseTuple(self,"OO",&pointer0,&pointer1);
	PointerOverlay* pointerOv0 = (PointerOverlay*)pointer0;
	PointerOverlay* pointerOv1 = (PointerOverlay*)pointer1;
	int id, width, height = 0;
	PyArg_ParseTuple(args,"iii",&id, &width,&height);

	if(id == 0)
		pointerOv0->InitAll(id,width,height);
	else if(id == 1)
		pointerOv1->InitAll(id,width,height);

	PyObject* res = Py_BuildValue("i",0);
	return res;
}

static PyObject* PointerModule_Reset(PyObject* self, PyObject* args)
{
	PyObject* pointer0;
	PyObject* pointer1;
	PyArg_ParseTuple(self,"OO",&pointer0,&pointer1);
	PointerOverlay* pointerOv0 = (PointerOverlay*)pointer0;
	PointerOverlay* pointerOv1 = (PointerOverlay*)pointer1;
	int id, width, height = 0;
	PyArg_ParseTuple(args,"iii",&id, &width,&height);

	if(id == 0)
		pointerOv0->Reset(id,width,height);
	else if(id == 1)
		pointerOv1->Reset(id,width,height);

	PyObject* res = Py_BuildValue("i",0);
	return res;
}

static PyObject* PointerModule_DrawPointer(PyObject* self, PyObject* args)
{
	PyObject* pointer0;
	PyObject* pointer1;
	PyArg_ParseTuple(self,"OO",&pointer0,&pointer1);
	PointerOverlay* pointerOv0 = (PointerOverlay*)pointer0;
	PointerOverlay* pointerOv1 = (PointerOverlay*)pointer1;

	int id,x,y = 0;
	PyArg_ParseTuple(args,"iii",&id,&x,&y);

	if(id == 0)
		pointerOv0->DrawFrame(x,y);
	else if(id == 1)
		pointerOv1->DrawFrame(x,y);

	PyObject* res = Py_BuildValue("i",0);
	return res;
}

static PyMethodDef PointerModuleMethods[] = {
    {"Init", PointerModule_Init, METH_VARARGS, "Init overlay"},
    {"Reset", PointerModule_Reset, METH_VARARGS, "Reset overlay"},
    {"DrawPointer", PointerModule_DrawPointer, METH_VARARGS, "Draw Pointer in overlay"},
    {NULL, NULL, 0, NULL}     /* Always use this as the last line in your table. */
};


PyMODINIT_FUNC initPointerModule(void)
{
	PointerOverlay* pointerOv0 = new PointerOverlay();
	PointerOverlay* pointerOv1 = new PointerOverlay();
	PyObject* pointers = Py_BuildValue("OO",(PyObject*)pointerOv0,(PyObject*)pointerOv1);
    (void) Py_InitModule4("PointerModule", PointerModuleMethods, NULL, pointers, PYTHON_API_VERSION);
}


int main(int argc, char* argv[])
{
	Py_SetProgramName(argv[0]);
	Py_Initialize();
	initPointerModule();
	return(EXIT_SUCCESS);
}